Subject: RE: bug#29949: 26.0.90; doc of `picture-mode-exit' and `picture-mode'

From: Drew Adams <[email-masked]>
Date: Tue, 2 Jan 2018 11:59:35 -0800 (PST)

> > 2. Both doc strings incorrectly give the impression that a line that
> > has only whitespace (e.g. space chars) is NOT stripped of its whitespace
> > chars if you provide an argument.
> >
> > The command functions correctly, which is to strip all such lines
> > except the one with point.  The whitespace preceding point on its
> > line is not stripped when you use a prefix arg.  This is the only
> > whitespace that is not stripped when you use a prefix arg.
> 
> I see nothing like what you describe.  The behavior I see is exactly
> what the doc strings say: trailing whitespace is removed, unless the
> exit command is invoked with C-u.  Empty lines are treated as any
> other trailing whitespace, i.e. removed in their entirety.

emacs -Q

(defun foo (&optional n)
  (interactive "*p")
  (picture-mode)
  (picture-open-line n)
  (picture-move-down n)
  (picture-mode-exit 'keep))

In *scratch*, put point on some text near the middle of the
first line.

M-3 M-x foo

The inserted blank lines are all empty, except the last one.
I believe this is the correct behavior.  Even though a prefix
arg is used, whitespace-only lines other than the one point
is on have all of their whitespace removed.

You can choose to describe this behavior differently than
I did.  But I think you will admit that the current
description is inaccurate, here.